PlayerCc::CameraProxy Class Reference
Proxies

The `CameraProxy` class can be used to get images from a camera device. More...

`#include <playerc++.h>`

Inheritance diagram for PlayerCc::CameraProxy:

## Public Member Functions

| CameraProxy (PlayerClient *aPc, uint32_t aIndex=0)
| Constructor.
void | SaveFrame (const std::string aPrefix, uint32_t aWidth=4)
| Save the frame. More...
void | Decompress ()
| decompress the image
uint32_t | GetDepth () const
| Image color depth.
uint32_t | GetWidth () const
| Image dimensions (pixels)
uint32_t | GetHeight () const
| Image dimensions (pixels)
uint32_t | GetFormat () const
| Image format Possible values include. More...
uint32_t | GetImageSize () const
| Size of the image (bytes)
void | GetImage (uint8_t *aImage) const
| Image data This function copies the image data into the data buffer aImage. More...
uint32_t | GetCompression () const
| What is the compression type? Currently supported compression types are: More...
Public Member Functions inherited from PlayerCc::ClientProxy
bool | IsValid () const
| Returns true if we have received any data from the device.
bool | IsFresh () const
| Fresh is set to true on each new read. More...
void | NotFresh ()
| This states that the data in a client is currently not Fresh.
std::string | GetDriverName () const
| Returns the driver name. More...
double | GetDataTime () const
| Returns the received timestamp [s].
double | GetElapsedTime () const
| Returns the received timestamp [s].
PlayerClient * | GetPlayerClient () const
| Returns a pointer to the Player Client.
uint32_t | GetIndex () const
| Returns device index.
uint32_t | GetInterface () const
| Returns device interface.
std::string | GetInterfaceStr () const
| Returns device interface.
void | SetReplaceRule (bool aReplace, int aType=-1, int aSubtype=-1)
| Set a replace rule for this proxy on the server. More...
int | HasCapability (uint32_t aType, uint32_t aSubtype)
| Request capabilities of device. More...
int | GetBoolProp (char *aProperty, bool *aValue)
| Request a boolean property.
int | SetBoolProp (char *aProperty, bool aValue)
| Set a boolean property.
int | GetIntProp (char *aProperty, int32_t *aValue)
| Request an integer property.
int | SetIntProp (char *aProperty, int32_t aValue)
| Set an integer property.
int | GetDblProp (char *aProperty, double *aValue)
| Request a double property.
int | SetDblProp (char *aProperty, double aValue)
| Set a double property.
int | GetStrProp (char *aProperty, char **aValue)
| Request a string property.
int | SetStrProp (char *aProperty, char *aValue)
| Set a string property.
template<typename T >
connection_t | ConnectReadSignal (T aSubscriber)
| Connect a signal to this proxy For more information check out Signals & multithreading.
void | DisconnectReadSignal (connection_t aSubscriber)
| Disconnect a signal to this proxy.

## Private Member Functions

virtual void | Subscribe (uint32_t aIndex)
virtual void | Unsubscribe ()

## Private Attributes

playerc_camera_t * | mDevice
std::string | mPrefix
int | mFrameNo

## Additional Inherited Members

Public Types inherited from PlayerCc::ClientProxy
typedef int | connection_t
typedef boost::mutex::scoped_lock | scoped_lock_t
typedef int | read_signal_t
Protected Member Functions inherited from PlayerCc::ClientProxy
| ClientProxy (PlayerClient *aPc, uint32_t aIndex)
template<typename T >
T | GetVar (const T &aV) const
template<typename T >
void | GetVarByRef (const T aBegin, const T aEnd, T aDest) const
Protected Attributes inherited from PlayerCc::ClientProxy
PlayerClient * | mPc
playerc_client_t * | mClient
playerc_device_t * | mInfo
bool | mFresh

## Detailed Description

The `CameraProxy` class can be used to get images from a camera device.

## Member Function Documentation

uint32_t PlayerCc::CameraProxy::GetCompression | ( |  | ) | const

inline

What is the compression type? Currently supported compression types are:

- PLAYER_CAMERA_COMPRESS_RAW
- PLAYER_CAMERA_COMPRESS_JPEG

uint32_t PlayerCc::CameraProxy::GetFormat | ( |  | ) | const

inline

Image format Possible values include.

- PLAYER_CAMERA_FORMAT_MONO8
- PLAYER_CAMERA_FORMAT_MONO16
- PLAYER_CAMERA_FORMAT_RGB565
- PLAYER_CAMERA_FORMAT_RGB888

void PlayerCc::CameraProxy::GetImage | ( | uint8_t * | aImage | ) | const

inline

Image data This function copies the image data into the data buffer aImage.

The buffer should be allocated according to the width, height, and depth of the image. The size can be found by calling GetImageSize().

void PlayerCc::CameraProxy::SaveFrame | ( | const std::string | aPrefix,
|  | uint32_t | aWidth = `4`
| ) |  |

Save the frame.

- aPrefix is the string prefix to name the image.
- aWidth is the number of 0s to pad the image numbering with.

The documentation for this class was generated from the following file:

- playerc++.h

Last updated 12 September 2005 21:38:45